#include "io.h"

// the messy buffer management part
void filebuf::overflow (int c) {
	flush () ;
	is_writing = true;
	x_pptr = buf;
	x_gptr = &buf[bufsiz];
	sputc (c) ;
}

void filebuf::underflow () {
	flush () ;
	is_writing = false;
	read(fd, buf, bufsiz);
	x_gptr = buf;
	x_pptr = &buf[bufsiz];
}

void filebuf::seek (long offset, int whence)
{
	flush () ;
	lseek (fd, offset, whence) ;
	is_writing = true;
	x_pptr = &buf [bufsiz] ;
	x_gptr = &buf[bufsiz];
}

filebuf::filebuf(const char *name, int om) {
	switch (om) {
	case ios::in:
		fd = open (name, O_RDONLY) ; break;
	case ios::out:
		fd = creat (name, 0666) ; break;
	case ios::in | ios::out:
		fd = open(name, O_RDWR | O_CREAT, 0666); break;
	}
}

filebuf:: ~filebuf () {
	flush() ;
	close(fd) ;
}
